#include-once

#include <Constants.au3>
#include <InetConstants.au3>
#include "utils.au3"
#include "ExitCodes.au3"

;Dim $wgetDir = TempFolder()
;ConsoleWrite("Installing wget to " & $wgetDir & @CRLF)
;FileInstall("wget.exe", $wgetDir & "\wget.exe")
;OnAutoItExitRegister("DeleteWget")

;Func DeleteWget()
;   ConsoleWrite("Deleting wget" & @CRLF)
;   DirRemove($wgetDir, 1)
;EndFunc


Func DownloadMultipleAddOnsFromCsv($sRepoDir, $sCsvFile)
   Local $aAddOns = _ParseCSV($sCsvFile)
   DownloadMultipleAddOns($sRepoDir, $aAddOns)
EndFunc

Func DownloadMultipleAddOns($sRepoDir, $aAddOns)
   For $i=0 To UBound($aAddOns)-1
	  Local $sUrl = $aAddOns[$i][0]
	  Local $sFile = $aAddOns[$i][1]
	  ;The tremaining CSV fields are not relevant here:
	  ;Local $sMethod = $aAddOns[$i][2]
	  ;Local $sExcludes = $aAddOns[$i][3]

	  DownloadAddOn($sUrl, $sFile, $sRepoDir)
   Next
EndFunc

;; Download $url to $file in $dir
;Func DownloadAddOn($url, $file, $dir)
;   Local $path = $dir & "\" & $file
;   Local $flags = "-N -v"
;   Local $cmd = $wgetDir & "\wget.exe " & $flags & " -O " & $path & " " & $url
;   ConsoleWrite($cmd & @CRLF)
;   RunWait($cmd)
;EndFunc

; Download $url to $file in $dir
Func DownloadAddOn($url, $file, $dir)
   Local $path = $dir & "\" & $file

   ConsoleWrite($file)
   If $url = "" Then
	  If FileExists($path) Then
		 ConsoleWrite(" present, URL not given." & @CRLF)
		 Return
	 Else
		 ConsoleWrite(" does not exist, and no URL given." & @CRLF)
		 MsgBox($MB_SYSTEMMODAL, "File missing", $file & " not found in repo and no URL given!")
		 Return
	  EndIf
   Endif

   Local $get = False
   If not FileExists($path) Then
	  $get = True
	  ConsoleWrite(" does not exist. " & @CRLF)
   Else
	  Local $localSize = FileGetSize($path)
	  Local $remoteSize = InetGetSize($url, $INET_FORCERELOAD)

	  If $remoteSize = 0 Then
		 $get = False
		 ConsoleWrite(" present, but server does not know size. Assuming OK. " & @CRLF)
	  ElseIf $remoteSize <> $localSize Then
		 $get = True
		 ConsoleWrite(" size mismatch local=" & $localSize & " server=" & $remoteSize  & @CRLF)
	  Else
		 $get = False
		 ConsoleWrite(" present, size matches server. OK. "  & @CRLF)
	  EndIf
   EndIf

   If $get Then
	  ;ProgressOn("Downloading", $file, $url)
	  ConsoleWrite("Downloading " & $file & " from " & $url & @CRLF)

	  Local $hDownload = InetGet($url, $path, $INET_FORCERELOAD, $INET_DOWNLOADBACKGROUND)
	  Do
		 Local $total = InetGetInfo($hDownload, $INET_DOWNLOADSIZE)
		 Local $read = InetGetInfo($hDownload, $INET_DOWNLOADREAD)
		 If ($total > 0) and ($read > 0) Then
			Local $pcnt = Round(100*$read/$total)
			;ProgressSet($pcnt)
			ConsoleWrite($pcnt & "%  " & @CR)
		 Endif
		 if InetGetInfo($hDownload, $INET_DOWNLOADERROR) Then
			ConsoleWrite("Error while downloading!" & @CRLF)
			MsgBox($MB_SYSTEMMODAL, "Download error", "on " & $file & " from " & $url)
			Exit $EXIT_DOWNLOADERROR
		 EndIf
	  Until InetGetInfo($hDownload, $INET_DOWNLOADCOMPLETE)
	  InetClose($hDownload)
	  ConsoleWrite(@CRLF)
	  ;ProgressOff()
   EndIf
EndFunc

